﻿
/*   Form1.cs
 * 
 * ****USB STEPPER MOTOR DRIVER USING PIC18F4550 v1.1**** 
 * **DEMO Communication Software for intreration with PIC18F4550**
 * 
 * This Software is free software: you free to redistribute it or 
 * modify the code way you wish. This software is for educational purpose only. 
 * The author will not be responsible for any loss or liability whatsoever.
 * 
 * This software bears no warranty or guarantee whatsoever. See the GNU General 
 * Public License for more details and clarification.You should have received a 
 * copy of the GNU General Public License along with this source code or software. 
 * If not, then feel free to see <http://www.gnu.org/licenses/>.
 * 
 * website source: www.rakeshmondal.info 
 * Free , no warranty  or guarantee whatsoever 
 * 
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using PICUSB;
using System.Runtime.InteropServices;

// lets start coding, PS: RON dont forget to comment or u will forget urself later. 
// alright facebook can wait, finish this coding first :/ :/ :V 

namespace steppermotor1byron
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        
/*
  Problem == [2012 - 2nd Nov - 2am ]
 * Open the links to Connection -done
 * Define the variables that I need for acessing the easyusbcomm
 * update the labels to avoid confusion !!
 * first try with single stepping - Done !! Phew :/ 
 * IF sucessful without much lagging in the result > then try added more stepping mode 
 * iF (you != lazy) {code today [add steppings!!] }  else { may be tomorrow; }
 * 
*/ 
     
       usb_interface usbcom = new usb_interface();   // Please talk to me USB !!!
        byte[] x_val = new byte[] { 0,1,2,3 };       // Gonna pass the value with this 
        byte[] y_val = new byte[] { 0,1,2,3 };       // one more for the preciding value
        byte[] val2;


/* *********  OK lets add steppings  ************************************* 

              Some references 
              http://en.wikipedia.org/wiki/Stepper_motor
              http://en.nanotec.com/main_en.swf awesome explanation 
              http://homepage.cs.uiowa.edu/~jones/step/
              ***************
 
************************************************************************* */


   // <Update>  [2012 - 3nd Nov - 10pm ] *****************
                private settingzz stepstepper;

                private enum settingzz
                {
                    wavez,
                    fullstep,
                    halfstep        // Half step added [ jan 2014] 
                } 

                string ron, hf, ss; // might need it somewhere 
                int a, b, c = 0;

    // </ Update>  [2012 - 3nd Nov - 10pm ] *******************

        //half step added on jan 2014


        // Adding a fn proto for making life easy 
        private void usbcommand() 
            {
                                                        // \/        \/  
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[0], x_val[0] }, out val2);
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[1], x_val[1] }, out val2);
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[2], x_val[2] }, out val2);
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[3], x_val[3] }, out val2);
            }
        

        private void button4_MouseUp(object sender, MouseEventArgs e) 
        {
            if (e.Button == MouseButtons.Left)
            {

                // Toggle modes 
                switch (stepstepper)
                {


                    case settingzz.wavez:
                        stepstepper = settingzz.fullstep;
                        label7.Text = " FULL";
                        break;             

                    case settingzz.fullstep:
                        stepstepper = settingzz.halfstep;
                        label7.Text = " Half";
                        break;

          case settingzz.halfstep: 
                     stepstepper = settingzz.wavez;
                     label7.Text = "wave";
                     break;
        
                                  
                  }
               }

             }

        // Button and timer romance :D :D

        private void button1_Click(object sender, EventArgs e)
        {
            if (!timerx.Enabled)
            {
                timerx.Start();
                button1.Text = "stop";
                label6.Text = "Running";
               // label5.Text = "timer running";
                textBox1.Enabled = false; // Dont forget to freeze the textbox1 :D
                button4.Enabled = false;
            }
            else
            { 
                timerx.Stop();

            label6.Text = "IDLE";
            button1.Text = "Start";
            textBox1.Enabled = true;  //Enable text box
            button4.Enabled = true;
            }
        }



     private int tictak = 0;  // well keeping it close for myself not to foeget. geezzzz this int thing. 
      
     private void timerx_Tick(object sender, EventArgs e)
        {
           timerx.Interval = Convert.ToInt32(textBox1.Text);  // accept timer delay(ms)value from textbox1

            switch(stepstepper)
             {

               
           //----- Stepping sequence selection protocol 


                 case settingzz.wavez:
                     {   //  x_val[0] = 0;
                         //  timerx.Interval = textBox1.Text; // damn why do I keep forgetting things.

                         if (tictak >= 4)
                         {
                             timerx.Enabled = false;
                             /* label6.Text = "IDLE";
                              button1.Text = "Start";
                              button1.Text = "Start again";
                              tictak = 0; */
                         }

                         else
                         {
                             usbcommand();

                             if (tictak == 0) // Okay lets start ticking the clock :D
                             {

                                 y_val[0] = 1; x_val[0] = 1;
                                 y_val[1] = 2; x_val[1] = 0;
                                 y_val[2] = 3; x_val[2] = 0;
                                 y_val[3] = 4; x_val[3] = 0;


                                 label1.Text = "1 ON";
                                 label2.Text = "2 OFF";
                                 label3.Text = "3 OFF";
                                 label4.Text = "4 OFF";
                                 tictak++;

                                 // Problems to fix? : Even if the timer USB dosent working or connected but still this label will update on and off, 
                                 // Hopefully will think of it tomorrow !!
                                 // Updated < adding a if then else for switch to work only on connection detect makes the form slow. 

                             }
                             else if (tictak == 1) // the first tick 
                             {
                                 y_val[0] = 1; x_val[0] = 0;
                                 y_val[1] = 2; x_val[1] = 1;
                                 y_val[2] = 3; x_val[2] = 0;
                                 y_val[3] = 4; x_val[3] = 0;

                                 label1.Text = "1 OFF";
                                 label2.Text = "2 ON";
                                 label3.Text = "3 OFF";
                                 label4.Text = "4 OFF";
                                 tictak++;
                             }


                             else if (tictak == 2)  // the second tick of the almighty clock !!!! :P 
                             {
                                 y_val[0] = 1; x_val[0] = 0;
                                 y_val[1] = 2; x_val[1] = 0;
                                 y_val[2] = 3; x_val[2] = 1;
                                 y_val[3] = 4; x_val[3] = 0;
                                 label1.Text = "1 OFF";
                                 label2.Text = "2 OFF";
                                 label3.Text = "3 ON";
                                 label4.Text = "4 OFF";
                                 tictak++;
                             }



                             else if (tictak == 3)  // the second tick of the almighty clock !!!! :P 
                             {
                                 y_val[0] = 1; x_val[0] = 0;
                                 y_val[1] = 2; x_val[1] = 0;
                                 y_val[2] = 3; x_val[2] = 0;
                                 y_val[3] = 4; x_val[3] = 1;
                                 label1.Text = "1 OFF";
                                 label2.Text = "2 OFF";
                                 label3.Text = "3 OFF";
                                 label4.Text = "4 ON";
                                 tictak=0; // well better to go to 0 ron, ++ was a bad idea last time, jst dnt forget 

                             }

                         }


                     } break;


//===================Full step sequence=================================================

     case settingzz.fullstep:

       {                      
                        
         if (tictak >= 4)
             {
                timerx.Enabled = false;
             /* label6.Text = "IDLE";
                button1.Text = "Start";
                button1.Text = "Start again";
                tictak = 0; */
             }

           else
                {                       
                   usbcommand();

           if (tictak == 0) // Okay lets start ticking the clock :D
                {

                   y_val[0] = 1; x_val[0] = 1;
                   y_val[1] = 2; x_val[1] = 1;
                   y_val[2] = 3; x_val[2] = 0;
                   y_val[3] = 4; x_val[3] = 0;

                   label1.Text = "1 ON"; // cant think of a better idea 
                   label2.Text = "2 ON";
                   label3.Text = "3 OFF";
                   label4.Text = "4 OFF";
                      tictak++;
      
                }
                  else if (tictak == 1)
                        {
                            y_val[0] = 1; x_val[0] = 0;
                            y_val[1] = 2; x_val[1] = 1;
                            y_val[2] = 3; x_val[2] = 1;
                            y_val[3] = 4; x_val[3] = 0;

                            label1.Text = "1 OFF"; // the second tick of the almighty clock !!!! :P 
                            label2.Text = "2 ON";
                            label3.Text = "3 ON";
                            label4.Text = "4 OFF";
                            tictak++;
                        }


                        else if (tictak == 2)
                        {
                            y_val[0] = 1; x_val[0] = 0;
                            y_val[1] = 2; x_val[1] = 0;
                            y_val[2] = 3; x_val[2] = 1;
                            y_val[3] = 4; x_val[3] = 1;
                            label1.Text = "1 OFF";
                            label2.Text = "2 OFF";
                            label3.Text = "3 ON";
                            label4.Text = "4 ON";
                            tictak++;
                        }



                   else if (tictak == 3)
                        {
                            y_val[0] = 1; x_val[0] = 1;
                            y_val[1] = 2; x_val[1] = 0;
                            y_val[2] = 3; x_val[2] = 0;
                            y_val[3] = 4; x_val[3] = 1;
                            label1.Text = "1 ON";
                            label2.Text = "2 OFF";
                            label3.Text = "3 OFF";
                            label4.Text = "4 ON";
                            tictak=0; // ok that worked alright. 

                        }

                     }
                                   
                } break;
                    
         
 //===========================Half step sequence ==========================
                       // Half step added [ jan 2014] 

     case settingzz.halfstep:
         {
             if (tictak >= 8)
             {
                 timerx.Enabled = false;
             }
             else
             {
                 usbcommand();

                 if (tictak == 0) // Okay lets start ticking the clock :D
                 {

                     y_val[0] = 1; x_val[0] = 1; // First excitation 
                     y_val[1] = 2; x_val[1] = 0; // Single phase excitation 
                     y_val[2] = 3; x_val[2] = 0;
                     y_val[3] = 4; x_val[3] = 0;

                     label1.Text = "1 ON";
                     label2.Text = "2 OFF";
                     label3.Text = "3 OFF";
                     label4.Text = "4 OFF";
                     tictak++;

                 }
                 else if (tictak == 1)
                 {
                     y_val[0] = 1; x_val[0] = 1; // Dual phase excitation og half stepping 
                     y_val[1] = 2; x_val[1] = 1;
                     y_val[2] = 3; x_val[2] = 0;
                     y_val[3] = 4; x_val[3] = 0;

                     label1.Text = "1 ON";
                     label2.Text = "2 ON";
                     label3.Text = "3 OFF";
                     label4.Text = "4 OFF";
                     tictak++;
                 }


                 else if (tictak == 2)
                 {
                     y_val[0] = 1; x_val[0] = 0;
                     y_val[1] = 2; x_val[1] = 1;
                     y_val[2] = 3; x_val[2] = 0;
                     y_val[3] = 4; x_val[3] = 0;
                     label1.Text = "1 OFF";
                     label2.Text = "2 ON";
                     label3.Text = "3 OFF";
                     label4.Text = "4 OFF";
                     tictak++;
                 }



                 else if (tictak == 3)
                 {
                     y_val[0] = 1; x_val[0] = 0;
                     y_val[1] = 2; x_val[1] = 1;
                     y_val[2] = 3; x_val[2] = 1;
                     y_val[3] = 4; x_val[3] = 0;
                     label1.Text = "1 OFF";
                     label2.Text = "2 ON";
                     label3.Text = "3 ON";
                     label4.Text = "4 OFF";
                     tictak++; // ok that worked alright. 

                 }
                 else if (tictak == 4)
                 {
                     y_val[0] = 1; x_val[0] = 0;
                     y_val[1] = 2; x_val[1] = 0;
                     y_val[2] = 3; x_val[2] = 1;
                     y_val[3] = 4; x_val[3] = 0;
                     label1.Text = "1 OFF";
                     label2.Text = "2 OFF";
                     label3.Text = "3 ON";
                     label4.Text = "4 OFF";
                     tictak++; // ok that worked alright. 

                 }
                 else if (tictak == 5)
                 {
                     y_val[0] = 1; x_val[0] = 0;
                     y_val[1] = 2; x_val[1] = 0;
                     y_val[2] = 3; x_val[2] = 1;
                     y_val[3] = 4; x_val[3] = 1;
                     label1.Text = "1 OFF";
                     label2.Text = "2 OFF";
                     label3.Text = "3 ON";
                     label4.Text = "4 ON";
                     tictak++; // ok that worked alright. 

                 }

                 else if (tictak == 6)
                 {
                     y_val[0] = 1; x_val[0] = 0;
                     y_val[1] = 2; x_val[1] = 0;
                     y_val[2] = 3; x_val[2] = 0;
                     y_val[3] = 4; x_val[3] = 1;
                     label1.Text = "1 OFF";
                     label2.Text = "2 OFF";
                     label3.Text = "3 OFF";
                     label4.Text = "4 ON";
                     tictak++; // ok that worked alright. 

                 }

                 else if (tictak == 7)
                 {
                     y_val[0] = 1; x_val[0] = 1;
                     y_val[1] = 2; x_val[1] = 0;
                     y_val[2] = 3; x_val[2] = 0;
                     y_val[3] = 4; x_val[3] = 1;
                     label1.Text = "1 ON";
                     label2.Text = "2 OFF";
                     label3.Text = "3 OFF";
                     label4.Text = "4 ON";
                     tictak=0; // ok that worked alright. 

                 }
             }

         } break;
       }
     }
     //=========================== END Half step sequence jan 2014 ==========================


        private void button2_Click(object sender, EventArgs e)
            {
                //Connect a led accross pin RD- 6 with a 1k resistance
                x_val[0] = 1;  
                y_val[0] = 5;
                byte[] val2;
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[0], x_val[0] }, out val2);
                label10.Text = "LED: ON";
            
               /* **** check connection **** */
         // IF (connection==exists) then { switch on led pin-5 (RD- 6) } Else { display an error}

                byte[] ping2;
                string idcheck = "vid_04d8&pid_000c"; // It freezes the button for a while but i guess am fine with it.
                usbcom.vid_pid_norm = idcheck;
                uint ping = usbcom.EasyCommand(0x00, 4, x_val, out ping2);
                if (ping == 0)
                {
                    label10.Text = "LINK NA";
                }

                else { }

            }

        private void button3_Click(object sender, EventArgs e)
            {
            
                x_val[0] = 0;
                y_val[0] = 1;
                byte[] val2;
                usbcom.EasyCommand(0x32, 1, new byte[] { y_val[0], x_val[0] }, out val2);
                label10.Text = "LED: OFF";
            }

             
        private void button5_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        
        /* ********* Connection Status Checking ************** */
        // IF (connection==exists) then { display success } Else { display an error and freeze buttons }

        private void button9_Click(object sender, EventArgs e)
        {
            
            byte[] ping2;
            string idcheck = "vid_04d8&pid_000c"; // Microchip vendor id 
            usbcom.vid_pid_norm = idcheck;
            uint ping = usbcom.EasyCommand(0x00, 4, x_val, out ping2);

            if (ping == 0)
            {
                label15.Text = "Not Connected";
             }
            else
                label15.Text = "PIC Detected";
                       
        }

        private void label7_Click(object sender, EventArgs e)
        {

        }

        private void groupBox3_Enter(object sender, EventArgs e)
        {

        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            string url = "http://www.rakeshmondal.info/USB-Stepper-Motor-Driver";
            System.Diagnostics.Process.Start(url);

        }

       
    }
}
